(function( $ ) {
	'use strict';

	jQuery(document).ready(function () {

		/**
		 * Shipping module settings
		 */

		// Add a row to the shipping costs table
		jQuery('body').on('click', 'table.shipping_rates a.add-row', function (e) {

			var table    = $(this).closest('table');
			var tbody    = table.find('tbody');

			// Delete sample warning if found
			tbody.find('tr.sample-values').remove();

			// Find last table row
			var last_row = tbody.find('tr:last');

			// Clone and reset fields
			var new_row  = last_row.clone();
			var index    = new_row.data('index');
			new_row.find('input').val('');
			new_row.find('select').val('');

			// Change index of form element
			new_row.attr('data-index', index + 1);
			new_row.find('input').each(function() {
				var name = $(this).attr('name');
				$(this).attr('name', name.replace('[' + index + ']', '[' + (index + 1) + ']'));
			});
			new_row.find('select').each(function() {
				var name = $(this).attr('name');
				$(this).attr('name', name.replace('[' + index + ']', '[' + (index + 1) + ']'));
			});

			// Append new element
			tbody.append(new_row);
			e.preventDefault();
		});

		// Delete a row from the shipping costs table
		jQuery('body').on('click', 'table.shipping_rates a.delete-row', function (e) {

			// Find the row with this button
			var tr = $(this).closest('tr');

			// Yellow flash
			tr.css("background-color", "#fcf75e");

			// Delete
			tr.fadeOut(600, function() {
				tr.remove();
			});
			e.preventDefault();
		});

		// Wait for WooCommerce to fill in the table with a timeout
		setTimeout( function () {
			let rows = $( '.wc-shipping-zone-method-rows' ).find( 'tr' );
			rows.each( function() {
				let tr = $( this );
				let id = tr.data( 'id' );

				// Does this zone use our shipping method?
				if ( mrwp_shipping.instance_ids.includes( id ) ) {

					// Yes, append duplicate link to existing actions
					let row_actions = tr.find( '.row-actions' );
					let ajax_url    = new URL( mrwp_shipping.base_url );
					ajax_url.searchParams.append( 'instance_id', id );
					let duplicate   = ' | <a href="' + ajax_url + '" class="mrwp-duplicate">' + mrwp_shipping.label + '</a>';
					row_actions.append( duplicate );
				}
			} );
		}, 10 );

	} );

} )( jQuery );
